Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.core
Class QFutureIterator<T>

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QFutureIterator<T>

All Implemented Interfaces:
  QtJambiInterface

    public class QFutureIterator<T>

extends QtJambiObject

The `QFutureIterator` class provides a Java-style const iterator for `QFuture`. `QFuture` has both Java-style iterators and STL-style iterators. The Java-style iterators are more high-level and easier to use than the STL-style iterators; on the other hand, they are slightly less efficient.

An alternative to using iterators is to use index positions. Some `QFuture` member functions take an index as their first parameter, making it possible to access results without using iterators.

`QFutureIterator`<T> allows you to iterate over a `QFuture`<T>. Note that there is no mutable iterator for `QFuture` (unlike the other Java-style iterators).

The `QFutureIterator` constructor takes a `QFuture` as its argument. After construction, the iterator is located at the very beginning of the result list (i.e. before the first result). Here's how to iterate over all the results sequentially:
The following code example is written in c++.

            QFuture<QString> future;
            ...
            QFutureIterator<QString> i(future);
            while (i.hasNext())
                qDebug() << i.next();

The `next()` function returns the next result (waiting for it to become available, if necessary) from the future and advances the iterator. Unlike STL-style iterators, Java-style iterators point between results rather than directly at results. The first call to `next()` advances the iterator to the position between the first and second result, and returns the first result; the second call to `next()` advances the iterator to the position between the second and third result, and returns the second result; and so on.
Here's how to iterate over the elements in reverse order:
The following code example is written in c++.

            QFutureIterator<QString> i(future);
            i.toBack();
            while (i.hasPrevious())
                qDebug() << i.previous();

If you want to find all occurrences of a particular value, use `findNext()` or `findPrevious()` in a loop.

Multiple iterators can be used on the same future. If the future is modified while a `QFutureIterator` is active, the `QFutureIterator` will continue iterating over the original future, ignoring the modified copy.

See also:
  QFuture::const_iterator, and `QFuture`.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QtJambiObject
`QtJambiObject.QPrivateConstructor`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1<A>, QSignalEmitter.Signal2<A,B>, QSignalEmitter.Signal3<A,B,C>, QSignalEmitter.Signal4<A,B,C,D>, QSignalEmitter.Signal5<A,B,C,D,E>, QSignalEmitter.Signal6<A,B,C,D,E,F>, QSignalEmitter.Signal7<A,B,C,D,E,F,G>, QSignalEmitter.Signal8<A,B,C,D,E,F,G,H>, QSignalEmitter.Signal9<A,B,C,D,E,F,G,H,I>`

Constructor Summary
`` | `QFutureIterator(QFuture<T> container)` Constructs an iterator for traversing `future`.
`protected` | `QFutureIterator(QtJambiObject.QPrivateConstructor p)` This method is internal to Qt Jambi.

Method Summary
`boolean` | `findNext(T t)` Searches for `value` starting from the current iterator position forward.
`boolean` | `findPrevious(T t)` Searches for `value` starting from the current iterator position backward.
`static QFutureIterator` | `fromNativePointer(QNativePointer nativePointer)` This method returns the QFutureIterator instance pointed to by `nativePointer`.
`boolean` | `hasNext()` Returns true if there is at least one result ahead of the iterator, e.g., the iterator is not at the back of the result list; otherwise returns false.
`boolean` | `hasPrevious()` Returns true if there is at least one result ahead of the iterator, e.g., the iterator is not at the front of the result list; otherwise returns false.
`T` | `next()` Returns the next result and advances the iterator by one position.
`T` | `peekNext()` Returns the next result without moving the iterator.
`T` | `peekPrevious()` Returns the previous result without moving the iterator.
`T` | `previous()` Returns the previous result and moves the iterator back by one position.
`void` | `toBack()` Moves the iterator to the back of the result list (after the last result).
`void` | `toFront()` Moves the iterator to the front of the result list (before the first result).

Methods inherited from class com.trolltech.qt.QtJambiObject
`disableGarbageCollection, dispose, disposed, equals, finalize, nativeId, nativePointer, reassignNativeResources, reenableGarbageCollection, setJavaOwnership, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`__qt_signalInitialization, blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### QFutureIterator

    public QFutureIterator(QFuture<T> container)

  Constructs an iterator for traversing `future`. The iterator is set to be at the front of the result list (before the first result).

See also:
  operator=().

### QFutureIterator

    protected QFutureIterator(QtJambiObject.QPrivateConstructor p)

  This method is internal to Qt Jambi.

Method Detail

### findNext

    public final boolean findNext(T t)

  Searches for `value` starting from the current iterator position forward. Returns true if `value` is found; otherwise returns false.

  After the call, if `value` was found, the iterator is positioned just after the matching result; otherwise, the iterator is positioned at the back of the result list.

See also:
  `findPrevious()`.

### findPrevious

    public final boolean findPrevious(T t)

  Searches for `value` starting from the current iterator position backward. Returns true if `value` is found; otherwise returns false.

  After the call, if `value` was found, the iterator is positioned just before the matching result; otherwise, the iterator is positioned at the front of the result list.

See also:
  `findNext()`.

### hasNext

    public final boolean hasNext()

  Returns true if there is at least one result ahead of the iterator, e.g., the iterator is not at the back of the result list; otherwise returns false.

See also:
  `hasPrevious()`, and `next()`.

### hasPrevious

    public final boolean hasPrevious()

  Returns true if there is at least one result ahead of the iterator, e.g., the iterator is not at the front of the result list; otherwise returns false.

See also:
  `hasNext()`, and `previous()`.

### next

    public final T next()

  Returns the next result and advances the iterator by one position.

  Calling this function on an iterator located at the back of the result list leads to undefined results.

See also:
  `hasNext()`, `peekNext()`, and `previous()`.

### peekNext

    public final T peekNext()

  Returns the next result without moving the iterator.

  Calling this function on an iterator located at the back of the result list leads to undefined results.

See also:
  `hasNext()`, `next()`, and `peekPrevious()`.

### peekPrevious

    public final T peekPrevious()

  Returns the previous result without moving the iterator.

  Calling this function on an iterator located at the front of the result list leads to undefined results.

See also:
  `hasPrevious()`, `previous()`, and `peekNext()`.

### previous

    public final T previous()

  Returns the previous result and moves the iterator back by one position.

  Calling this function on an iterator located at the front of the result list leads to undefined results.

See also:
  `hasPrevious()`, `peekPrevious()`, and `next()`.

### toBack

    public final void toBack()

  Moves the iterator to the back of the result list (after the last result).

See also:
  `toFront()`, and `previous()`.

### toFront

    public final void toFront()

  Moves the iterator to the front of the result list (before the first result).

See also:
  `toBack()`, and `next()`.

### fromNativePointer

    public static QFutureIterator fromNativePointer(QNativePointer nativePointer)

  This method returns the QFutureIterator instance pointed to by `nativePointer`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD